﻿Imports System.Windows.Forms

Public Class BacksideDialog
    Private Const KleineKarteSizeX = 36
    Private Const KleineKarteSizeY = 48
    Private Const AbstandX = 10
    Private Const AbstandY = 10


    Friend nBackSide As Integer

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub BacksideDialog_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        nBackSide = My.Settings.BackSide
        If nBackSide < BackSide.Wolken OrElse nBackSide > BackSide.Autos Then nBackSide = BackSide.Wolken
        Dim BS As Integer = BackSide.Wolken

        For dY = AbstandY To (2 * AbstandY + KleineKarteSizeY) Step KleineKarteSizeY + AbstandY
            For dX = AbstandX To (6 * AbstandX + 5 * KleineKarteSizeX) Step KleineKarteSizeX + AbstandX
                Dim item As New CardBox(New Card(BS, KleineKarteSizeX, KleineKarteSizeY), dX, dY, _
                                        KleineKarteSizeX, KleineKarteSizeY, ShowF.LittleCard, False)
                item.Name = "cardbox" & BS.ToString
                Me.Controls.Add(item)
                AddHandler item.MouseClick, AddressOf Item_Click

                BS += 1
            Next
        Next

    End Sub
   
    Private Sub Item_Click(ByVal sender As CardBox, ByVal e As System.Windows.Forms.MouseEventArgs)
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Dim g As Graphics = Me.CreateGraphics
            Dim MyPen As New Pen(Me.BackColor, 2)

            For Each item As Control In Me.Controls
                If item.Name.Contains("cardbox") Then
                    If Val(Microsoft.VisualBasic.Right(item.Name, 2)) = nBackSide Then
                        g.DrawRectangle(MyPen, item.Left - 2, item.Top - 2, KleineKarteSizeX + 4, KleineKarteSizeY + 4)
                    End If
                End If
            Next

            MyPen = New Pen(Color.Blue, 2)
            g.DrawRectangle(MyPen, sender.Left - 2, sender.Top - 2, KleineKarteSizeX + 4, KleineKarteSizeY + 4)

            nBackSide = Val(Microsoft.VisualBasic.Right(sender.Name, 2))

        End If

    End Sub

    Private Sub BacksideDialog_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint

        For Each item As Control In Me.Controls
            If item.Name.Contains("cardbox") Then
                If Val(Microsoft.VisualBasic.Right(item.Name, 2)) = nBackSide Then
                    e.Graphics.DrawRectangle(New Pen(Color.Blue, 2), item.Left - 2, item.Top - 2, KleineKarteSizeX + 4, KleineKarteSizeY + 4)
                End If

            End If
        Next
    End Sub
End Class
