﻿Public Class CardBox

    Inherits Control

#Region "Properties"

    Public Shared MouseButtonPressed As Boolean

    Public PMousePosX As Integer
    Public PMousePosY As Integer
    Public Portable As Boolean

    Private PCard As Card
    Private PShowFace As ShowF
    Private PStartPosX As Integer
    Private PStartPosY As Integer
    Private PBorder As Boolean = False
    Private PBorderColor As Color
   

    Public Property Card() As Card
        Get
            Return PCard
        End Get
        Set(ByVal value As Card)
            PCard = value
            Me.Refresh() ' raises the paint event
        End Set
    End Property
    Public Property ShowFace() As ShowF
        Get
            Return PShowFace
        End Get
        Set(ByVal value As ShowF)
            If PShowFace <> value Then
                PShowFace = value
                If PShowFace = ShowF.Face Then
                    Me.Portable = True
                Else
                    Me.Portable = False
                End If
                Me.Refresh()           '        redraws
            End If
        End Set
    End Property
    Public Property StartPosX() As Integer
        Get
            Return PStartPosX
        End Get
        Set(ByVal value As Integer)
            If PStartPosX <> value Then
                PStartPosX = value
            End If
            Me.Left = value  ' causes redraw
        End Set
    End Property
    Public Property StartPosY() As Integer
        Get
            Return PStartPosY
        End Get
        Set(ByVal value As Integer)
            If PStartPosY <> value Then
                PStartPosY = value
            End If
            Me.Top = value ' causes redraw
        End Set
    End Property
    Public Property Border() As Boolean
        Get
            Return PBorder
        End Get
        Set(ByVal value As Boolean)
            PBorder = value
            Refresh()
        End Set
    End Property
    Public Property BorderColor() As Color
        Get
            Return PBorderColor
        End Get
        Set(ByVal value As Color)
            PBorderColor = value
            Refresh()
        End Set
    End Property

#End Region

    Public Sub New(ByVal card As Card, _
                   Optional ByVal nStartPosX As Integer = 0, Optional ByVal nStartPosY As Integer = 0, _
                   Optional ByVal nSizeX As Integer = MainForm.KartenSizeX, Optional ByVal nSizeY As Integer = MainForm.KartenSizeY, _
                   Optional ByVal nShowFace As ShowF = ShowF.Face, Optional ByVal nPortable As Boolean = True)

        PCard = card
        StartPosX = nStartPosX
        StartPosY = nStartPosY
        Me.Size = New Size(nSizeX, nSizeY)
        PShowFace = nShowFace
        Me.Portable = nPortable
        PBorderColor = Color.Black

    End Sub

    Private Sub Me_Paint(ByVal sender As CardBox, _
                         ByVal e As PaintEventArgs) Handles Me.Paint

        Select Case PShowFace
            Case ShowF.Face
                sender.Card.PaintGraphic(Graphics.FromHwnd(sender.Handle), 0, 0)
            Case ShowF.Backside
                If My.Settings.BackSide < BackSide.Farbe OrElse My.Settings.BackSide > BackSide.Autos Then My.Settings.BackSide = BackSide.Farbe
                sender.Card.PaintGraphicBack(Graphics.FromHwnd(sender.Handle), 0, 0, My.Settings.BackSide, 0)
            Case ShowF.LittleCard
                sender.Card.PaintGraphic(Graphics.FromHwnd(sender.Handle), 0, 0, MainForm.KartenSizeX / 2, MainForm.KartenSizeY / 2, Me.Card.CardID, 1, 0)
            Case ShowF.ColorGreen
                sender.Card.PaintGraphicBack(Graphics.FromHwnd(sender.Handle), 0, 0, BackSide.Farbe, ColorTranslator.ToOle(Color.Green))
            Case ShowF.NullCard
                sender.Card.PaintGraphicBack(Graphics.FromHwnd(sender.Handle), 0, 0, Me.Card.CardID, 0)
            Case ShowF.EmptyCard
                sender.Card.PaintGraphicBack(Graphics.FromHwnd(sender.Handle), 0, 0, BackSide.leer, 0)
        End Select
        'Rectangle wird um KartenAbstandY tiefer gezeichnet, weil die "unten"-boxen um den Kartenabstand höher liegen!!!
        'Diese Boxen sind auch um KartenAbstandY höher!
        If PBorder Then
            e.Graphics.DrawRectangle(New Pen(PBorderColor, 1), 0, MainForm.KartenAbstandY, _
                                     MainForm.KartenSizeX - 1, MainForm.KartenSizeY - 1)
        End If

    End Sub
    Private Sub Me_MouseDown(ByVal sender As CardBox, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        If Not MainForm.Timer1.Enabled AndAlso My.Settings.ShowTime Then
            MainForm.Anfangszeitpunkt = Now
            MainForm.Timer1.Start()
        End If

        If e.Button = Windows.Forms.MouseButtons.Left AndAlso Me.Portable Then
            If Me.liegt = liegtE.amTalonrechts AndAlso Not Me.IsHighest Then Exit Sub

            MouseButtonPressed = True
            MainForm.GetHighestBoxes()

            If sender.IsHighest Then
                sender.BringToFront()
                PMousePosX = e.X
                PMousePosY = e.Y

            Else ' move more than one cardbox

                MainForm.AFewCardBoxes.Clear()
                For Each item As CardBox In MainForm.CardBoxes
                    If sender.Left = item.Left AndAlso sender.Top <= item.Top Then
                        MainForm.AFewCardBoxes.Add(item)
                    End If
                Next

                MainForm.AFewCardBoxes.Sort(New CardBoxComparerByPosY)
                For Each item As CardBox In MainForm.AFewCardBoxes
                    item.BringToFront()
                    item.PMousePosX = e.X
                    item.PMousePosY = e.Y
                Next

            End If
        End If

    End Sub
    Private Sub Me_MouseMove(ByVal sender As CardBox, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove

        If MouseButtonPressed Then
            If sender.IsHighest Then
                sender.Left = sender.Left - PMousePosX + e.X
                sender.Top = sender.Top - PMousePosY + e.Y
            Else
                For Each item As CardBox In MainForm.AFewCardBoxes
                    item.Left = item.Left - item.PMousePosX + e.X
                    item.Top = item.Top - item.PMousePosY + e.Y
                Next
            End If

        End If

    End Sub
    'Private Sub item_MouseUp(ByVal sender As CardBox, ByVal e As System.Windows.Forms.MouseEventArgs)
    ' dieser code muss in der Mainform stehen

    'AddHandler Item.MouseUp, AddressOf Item_MouseUp
    '    End Sub

    ' Private Sub Me_DoubleClick(ByVal sender As CardBox, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.DoubleClick
    '    Select Case PShowFace
    '       Case ShowF.Face
    '          ShowFace = ShowF.Backside
    '     Case ShowF.Backside
    '        ShowFace = ShowF.Face
    ' End Select

    ' End Sub

    Public Function IsHighest() As Boolean
        Dim Erg As Boolean = True
        For Each item As CardBox In MainForm.CardBoxes

            If Me.Left < item.Right AndAlso Me.Right > item.Left AndAlso Me.Top < item.Bottom AndAlso Me.Bottom > item.Top Then
                If MainForm.Controls.GetChildIndex(Me) > MainForm.Controls.GetChildIndex(item) Then Erg = False
            End If
        Next
        Return Erg
    End Function
    Public Function liegt() As liegtE
        If StartPosY = MainForm.AbstandY Then
            If StartPosX = MainForm.AbstandX Then liegt = liegtE.amTalonlinks
            If StartPosX >= MainForm.AbstandX + MainForm.KartenSizeX + MainForm.KartenAbstandX Then liegt = liegtE.amTalonrechts
            If StartPosX >= MainForm.AbstandX + (3 * (MainForm.KartenSizeX + MainForm.KartenAbstandX)) Then liegt = liegtE.amStapel
        Else
            liegt = liegtE.unten
        End If
    End Function
    Public Function GetFullDescription() As String
        Dim msg As String = Me.Card.ToString & vbCrLf
        msg &= "Name: " & Me.Name & vbCrLf
        msg &= "IsHighest: " & IsHighest.ToString & vbCrLf
        msg &= "Liegt  " & liegt.ToString & vbCrLf

        msg &= "z-order" & MainForm.Controls.GetChildIndex(Me).ToString
        Return msg
    End Function

    Public Class CardBoxComparerByPosY
        Inherits Comparer(Of CardBox)

        Public Overrides Function Compare(ByVal cb1 As CardBox, ByVal cb2 As CardBox) As Integer
            Return cb1.StartPosY.CompareTo(cb2.StartPosY)
        End Function
    End Class
    Public Class CardBoxComparerByZOrder
        Inherits Comparer(Of CardBox)

        Public Overrides Function Compare(ByVal x As CardBox, ByVal y As CardBox) As Integer
            Return MainForm.Controls.GetChildIndex(x).CompareTo(MainForm.Controls.GetChildIndex(y))
        End Function
    End Class
    Public Class CardBoxComparerByRank
        Inherits Comparer(Of CardBox)

        Public Overrides Function Compare(ByVal x As CardBox, ByVal y As CardBox) As Integer
            '  this code for other rankings
            '  Dim RANKS() As String = {"A", "2", "3", "4", "5", "6", "7", "8", "9", "T", "J", "Q", "K"}
            ' Dim XRank As Integer = 4 * (Array.IndexOf(RANKS, Microsoft.VisualBasic.Right(x.Card.ToShortString, 1)))
            'Dim YRank As Integer = 4 * (Array.IndexOf(RANKS, Microsoft.VisualBasic.Right(y.Card.ToShortString, 1)))
            'XRank += CInt(x.Card.Suit)
            'YRank += CInt(y.Card.Suit)
            'Return XRank.CompareTo(YRank)

            Return CInt(x.Card.CardID).CompareTo(CInt(y.Card.CardID))

        End Function
    End Class
End Class

Public Class Card
    Private FCard As Integer
    Private Shared initialized As Boolean = False
    Private Shared pWidth As Integer
    Private Shared pHeight As Integer

#Region "External methods and related fields"

    Private Declare Function cdtInit Lib "cards.dll" ( _
      ByRef width As Integer, ByRef height As Integer) As Boolean
    Private Declare Function cdtDrawExt Lib "cards.dll" ( _
      ByVal hdc As IntPtr, ByVal x As Integer, ByVal y As Integer, _
      ByVal dx As Integer, ByVal dy As Integer, ByVal card As Integer, _
      ByVal suit As Integer, ByVal color As Long) As Boolean
    Private Declare Sub cdtTerm Lib "cards.dll" ()
    Private Declare Function cdtDraw Lib "cards.dll" ( _
      ByVal hdc As IntPtr, ByVal x As Integer, ByVal y As Integer, _
      ByVal card As Integer, _
      ByVal suit As Integer, ByVal color As Long) As Boolean

#End Region

    Public Shared Sub Init()
        If (initialized) Then Return
        initialized = True
        cdtInit(pWidth, pHeight)
    End Sub
    Public Shared Sub Deinit()
        If (Not initialized) Then Return
        initialized = False
        cdtTerm()
    End Sub

    Public Sub New(Optional ByVal nCard As Integer = BackSide.Farbe, Optional ByVal nWidth As Integer = MainForm.KartenSizeX, _
                   Optional ByVal nHeight As Integer = MainForm.KartenSizeY)
        Init()
        FCard = nCard
        pWidth = nWidth
        pHeight = nHeight

    End Sub
    Public Overloads Sub SetCard(ByVal CardID As Integer)
        FCard = CardID
    End Sub
    Public Overloads Sub SetCard(ByVal newSuit As SuitE, ByVal newFace As Face)
        Me.Suit = newSuit
        Me.Face = newFace
    End Sub

    Public Property CardID() As Integer
        Get
            Return FCard
        End Get
        Set(ByVal value As Integer)
            FCard = value
        End Set
    End Property
    Public Property Suit() As SuitE
        Get
            Return FCard Mod 4
        End Get
        Set(ByVal Value As SuitE)
            FCard = (FCard \ 4) * 4 + Value
        End Set
    End Property
    Public Property Face() As Face
        Get
            Return FCard \ 4
        End Get
        Set(ByVal value As Face)
            FCard = (value * 4) + FCard Mod 4
        End Set
    End Property

    Public Function IsRedCard() As Boolean
        If Suit = MySolitaire.SuitE.Herz OrElse Suit = MySolitaire.SuitE.Karo Then
            Return True
        Else
            Return False
        End If

    End Function
    Public Function IsBlackCard() As Boolean

        If Suit = MySolitaire.SuitE.Pik OrElse Suit = MySolitaire.SuitE.Treff Then
            Return True
        Else
            Return False
        End If

    End Function

    Public Overrides Function ToString() As String

        Dim outStr As String = ""
        Select Case Suit
            Case SuitE.Herz : outStr = "Herz "
            Case SuitE.Karo : outStr = "Karo "
            Case SuitE.Pik : outStr = "Pik "
            Case SuitE.Treff : outStr = "Treff "
        End Select
        Select Case Face
            Case Face.Two : outStr &= "2"
            Case Face.Three : outStr &= "3"
            Case Face.Four : outStr &= "4"
            Case Face.Five : outStr &= "5"
            Case Face.Six : outStr &= "6"
            Case Face.Seven : outStr &= "7"
            Case Face.Eight : outStr &= "8"
            Case Face.Nine : outStr &= "9"
            Case Face.Ten : outStr &= "10"
            Case Face.Jack : outStr &= "Bub"
            Case Face.Queen : outStr &= "Dame"
            Case Face.King : outStr &= "König"
            Case Face.Ace : outStr &= "Ass"
        End Select
        Return outStr

    End Function
    Public Function ToShortString() As String

        Dim outStr As String = ""
        Select Case Suit
            Case SuitE.Herz : outStr = "H"
            Case SuitE.Karo : outStr = "D"
            Case SuitE.Pik : outStr = "S"
            Case SuitE.Treff : outStr = "C"
        End Select
        Select Case Face
            Case Face.Two : outStr &= "2"
            Case Face.Three : outStr &= "3"
            Case Face.Four : outStr &= "4"
            Case Face.Five : outStr &= "5"
            Case Face.Six : outStr &= "6"
            Case Face.Seven : outStr &= "7"
            Case Face.Eight : outStr &= "8"
            Case Face.Nine : outStr &= "9"
            Case Face.Ten : outStr &= "T"
            Case Face.Jack : outStr &= "J"
            Case Face.Queen : outStr &= "Q"
            Case Face.King : outStr &= "K"
            Case Face.Ace : outStr &= "A"
        End Select
        Return outStr


    End Function

    Public Overloads Sub PaintGraphic(ByVal g As Graphics, ByVal x As Integer, _
      ByVal y As Integer)

        Dim hdc As IntPtr = g.GetHdc()
        Try
            cdtDraw(hdc, x, y, FCard, 0, 0)
        Finally
            g.ReleaseHdc(hdc)
        End Try

    End Sub
    Public Overloads Sub PaintGraphic(ByVal g As Graphics, ByVal x As Integer, _
      ByVal y As Integer, ByVal dx As Integer, ByVal dy As Integer, _
      ByVal nCard As Integer, ByVal nDraw As Integer, ByVal nColor As Long)

        Dim hdc As IntPtr = g.GetHdc()
        Try
            cdtDrawExt(hdc, x, y, dx, dy, nCard, nDraw, nColor)
        Finally
            g.ReleaseHdc(hdc)
        End Try

    End Sub
    Public Sub PaintGraphicBack(ByVal g As Graphics, ByVal x As Integer, _
      ByVal y As Integer, ByVal BS As BackSide, ByVal nColor As Long)

        Dim hdc As IntPtr = g.GetHdc()
        Try
            cdtDraw(hdc, x, y, BS, 1, nColor)
        Finally
            g.ReleaseHdc(hdc)
        End Try

    End Sub
    Public Class CardComparer
        Implements IComparer(Of Card)
        Public Function Compare(ByVal x As Card, ByVal y As Card) As Integer Implements System.Collections.Generic.IComparer(Of Card).Compare
            Dim RANKS() As String = {"A", "K", "Q", "J", "T", "9", "8", "7", "6", "5", "4", "3", "2"}
            Dim Xi = Array.IndexOf(Of String)(RANKS, CStr(x.ToShortString)(1))
            Dim Yi = Array.IndexOf(Of String)(RANKS, CStr(y.ToShortString)(1))
            Return Xi.CompareTo(Yi)
        End Function
    End Class
End Class

Public Enum Face As Integer
    Ace
    Two
    Three
    Four
    Five
    Six
    Seven
    Eight
    Nine
    Ten
    Jack
    Queen
    King
    Leer = 16
End Enum
Public Enum SuitE As Integer
    ' Diamond = 0
    ' Club = 1
    ' Heart = 2
    ' Spade = 3
    Treff
    Karo
    Herz
    Pik
    Leer = 2
End Enum
Public Enum BackSide As Integer
    Farbe = 53
    Wolken = 54
    blau = 55
    Fisch = 56
    Frosch = 57
    RoteWelle = 58
    Strand = 59
    BlauKariert = 60
    violett = 61
    Wueste = 62
    Astronaut = 63
    orangeStreifen = 64
    Autos = 65
    leer = 66
    X = 67
    O = 68

End Enum
Public Enum ShowF As Integer
    Face
    Backside
    LittleCard
    ColorGreen
    NullCard
    EmptyCard
End Enum
Public Enum liegtE As Integer
    unten
    amTalonlinks
    amTalonrechts
    amStapel

End Enum