﻿
Public Class MainForm

#Region "Definitions"

    Friend AbstandX As Integer = 10
    Friend Const AbstandY As Integer = 30
    Friend Const KartenSizeX As Integer = 72
    Friend Const KartenSizeY As Integer = 96
    Friend KartenAbstandX As Integer = 10
    Friend Const KartenAbstandY As Integer = 15
    Private Const KartenAbstandUntenVerdeckt = 3

    Friend NullCardBox As New CardBox(New Card(), AbstandX, AbstandY)

    Friend CardBoxes As New List(Of CardBox)
    Friend AFewCardBoxes As New List(Of CardBox)
    Private HighestBoxes As New List(Of CardBox)

    Private Deck As New List(Of Card)
    Private UnDoWerte As New List(Of UnDoWert)

    Private WithEvents Punk As New Punkte()
    Friend Anfangszeitpunkt As Date
    Private Zeit As TimeSpan
    Private rightClickMove As Boolean
    Private Const VegasDeckKostet As Integer = 52

    Private Class Punkte
        Event ValueChanged()
        Private pte As Integer = 0
        Public Property te() As Integer
            Get
                Return pte
            End Get
            Set(ByVal value As Integer)
                If value <> pte Then
                    pte = value
                    If My.Settings.PunkteZaehlen = PunkteZ.Standard AndAlso pte < 0 Then pte = 0
                    RaiseEvent ValueChanged()
                End If
            End Set
        End Property
        Public Sub New()
            te = 0
        End Sub
    End Class

    Private Structure UnDoWert
        Friend BK_Name As String
        Friend BK_StartPosX As Integer
        Friend BK_StartPosY As Integer
        Friend BK_ShowFace As ShowF
        Friend Punkte_Dazu As Integer
        Friend UnDoWiederholen As Boolean
    End Structure

#End Region

    Private Sub MainForm_Load(ByVal sender As Object, _
                              ByVal e As System.EventArgs) _
                              Handles Me.Load

        Card.Init()
        Me.Location = My.Settings.MainFormPos
        KartenNeuGebenToolStripMenuItem_Click(sender, e)

        StatusBar.Visible = My.Settings.ShowStatusBar
        TSSLabel1.Visible = My.Settings.ShowTime
        ZeitTSSLabel.Visible = My.Settings.ShowTime

        Select Case My.Settings.PunkteZaehlen
            Case PunkteZ.Keine
                TSSLabel2.Visible = False
                PunkteTSSLabel.Visible = False
            Case PunkteZ.LasVegas
                TSSLabel2.Visible = True
                PunkteTSSLabel.Visible = True
                If Punk.te < 0 Then PunkteTSSLabel.ForeColor = Color.Red
                PunkteTSSLabel.Text = String.Format("{0:C0}", Punk.te)
            Case PunkteZ.Standard
                TSSLabel2.Visible = True
                PunkteTSSLabel.Visible = True
                PunkteTSSLabel.Text = Punk.te.ToString
            Case Else
                TSSLabel2.Visible = True
                PunkteTSSLabel.Visible = True
                PunkteTSSLabel.Text = Punk.te.ToString
        End Select



    End Sub

    Private Sub KartenNeuGebenToolStripMenuItem_Click(ByVal sender As System.Object, _
                                                      ByVal e As System.EventArgs) _
                                                      Handles KartenNeuGebenToolStripMenuItem.Click
        'reset

        Me.Controls.Clear()
        InitializeComponent()
        HighestBoxes.Clear()
        AFewCardBoxes.Clear()
        CardBoxes.Clear()
        UnDoWerte.Clear()

        If Timer1.Enabled Then Timer1.Stop()
        If My.Settings.PunkteZaehlen = PunkteZ.LasVegas Then
            If My.Settings.PunkteBehalten Then
                Punk.te -= VegasDeckKostet
            Else
                Punk.te = 0 - VegasDeckKostet
            End If
        Else
            Punk.te = 0
        End If

        Deck_create_and_shuffle()

        ' create "O" cardbox
        Dim NullKarte As Integer = BackSide.O
        If My.Settings.PunkteZaehlen = PunkteZ.LasVegas Then NullKarte = BackSide.X

        NullCardBox.Card = New Card(NullKarte)
        NullCardBox.Name = "NullCardBox"
        NullCardBox.ShowFace = ShowF.NullCard
        NullCardBox.Anchor = AnchorStyles.Top
        Me.Controls.Add(NullCardBox)
        AddHandler NullCardBox.Click, AddressOf NullCard_Click

        ' create free places below
        For i = 0 To 6
            Dim item As New CardBox(New Card(BackSide.leer), (i * (KartenSizeX + KartenAbstandX)) + AbstandX, AbstandY + KartenSizeY)
            item.Name = "Unten" & i.ToString
            item.ShowFace = ShowF.EmptyCard
            item.Height += KartenAbstandY
            item.Border = True
            item.Anchor = AnchorStyles.Top
            Me.Controls.Add(item)
            CardBoxes.Add(item)
            AddHandler item.Click, AddressOf Item_Click
        Next

        ' create Stapel
        For i = 1 To 4
            Dim item As New CardBox(New Card(), (i * (KartenSizeX + KartenAbstandX)) + (2 * (KartenSizeX + KartenAbstandX)) + AbstandX, AbstandY)
            item.Name = "Stapel" & i.ToString
            item.ShowFace = ShowF.ColorGreen
            item.Anchor = AnchorStyles.Top
            Me.Controls.Add(item)
            CardBoxes.Add(item)
            AddHandler item.Click, AddressOf Item_Click
            item.BringToFront()
        Next

        ' create StandardCardBoxes below
        Dim Nr As Integer = 1
        Dim sf As Boolean = True
        For j = 0 To 6
            sf = True
            For i = j To 6
                Dim item As New CardBox(TakeCardFromDeck, (i * (KartenSizeX + KartenAbstandX)) + AbstandX, _
                                        AbstandY + KartenSizeY + KartenAbstandY + (j * KartenAbstandUntenVerdeckt))
                item.Name = "StdCardBox" & String.Format("{0:00}", Nr)

                If Not sf Then
                    item.ShowFace = ShowF.Backside
                End If
                sf = False
                item.Anchor = AnchorStyles.Top
                Me.Controls.Add(item)
                CardBoxes.Add(item)
                item.BringToFront()
                AddHandler item.Click, AddressOf Item_Click
                AddHandler item.DoubleClick, AddressOf Item_MoveUp
                Nr += 1
            Next i
        Next j

        'create rest of cardboxes
        For i = 29 To 52      '28 Karten wurden bereits verteilt(1+2+3+4+5+6+7), 52 gibts insgesamt
            Dim item As New CardBox(TakeCardFromDeck, AbstandX, AbstandY)
            item.Name = "StdCardBox" & i.ToString
            item.ShowFace = ShowF.Backside
            item.Anchor = AnchorStyles.Top
            Me.Controls.Add(item)
            CardBoxes.Add(item)
            item.BringToFront()
            AddHandler item.Click, AddressOf Item_Click
            AddHandler item.DoubleClick, AddressOf Item_MoveUp
        Next

    End Sub
    Private Sub UnDoToolStripMenuItem_Click(ByVal sender As System.Object, _
                                            ByVal e As System.EventArgs) _
                                            Handles UnDoToolStripMenuItem.Click

        If UnDoWerte.Count = 0 Then Exit Sub
        Dim WiederHolen As Boolean = True
        Do While WiederHolen
            Dim UnDo As UnDoWert = UnDoWerte.Item(0)
            For Each item As CardBox In CardBoxes
                If item.Name = UnDo.BK_Name Then
                    item.StartPosX = UnDo.BK_StartPosX
                    item.StartPosY = UnDo.BK_StartPosY
                    item.ShowFace = UnDo.BK_ShowFace
                    item.BringToFront()
                    Exit For
                End If
            Next
            WiederHolen = UnDoWerte.Item(0).UnDoWiederholen
            Punk.te -= UnDo.Punkte_Dazu
            UnDoWerte.RemoveAt(0)
        Loop


        If UnDoWerte.Count > 0 Then
            UnDoToolStripMenuItem.Enabled = True
        Else
            UnDoToolStripMenuItem.Enabled = False
        End If

    End Sub
    Private Sub DeckblattToolStripMenuItem_Click(ByVal sender As System.Object, _
                                                 ByVal e As System.EventArgs) _
                                                 Handles DeckblattToolStripMenuItem.Click

        If BacksideDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            If My.Settings.BackSide <> BacksideDialog.nBackSide Then
                My.Settings.BackSide = BacksideDialog.nBackSide
                For Each item As CardBox In CardBoxes
                    If item.ShowFace = ShowF.Backside Then item.Refresh()
                Next
            End If

        End If


        Dim cb As New CardBox(New Card())    ' for re init

    End Sub
    Private Sub OptionenToolStripMenuItem_Click(ByVal sender As System.Object, _
                                                ByVal e As System.EventArgs) _
                                                Handles OptionenToolStripMenuItem.Click
        If OptionenDialog.ShowDialog = Windows.Forms.DialogResult.OK Then

            Dim neuGeben As Boolean = False
            If Not My.Settings.KartenZiehen = OptionenDialog.KartenZiehen Then
                My.Settings.KartenZiehen = OptionenDialog.KartenZiehen
                neuGeben = True
            End If
            If Not My.Settings.PunkteZaehlen = OptionenDialog.PunkteZaehlen Then
                My.Settings.PunkteZaehlen = OptionenDialog.PunkteZaehlen
                neuGeben = True
            End If
            If Not My.Settings.ShowTime = OptionenDialog.ZeigeZeitCB.Checked Then
                My.Settings.ShowTime = OptionenDialog.ZeigeZeitCB.Checked
                TSSLabel1.Visible = My.Settings.ShowTime
                ZeitTSSLabel.Visible = My.Settings.ShowTime
                neuGeben = True
                ZeitTSSLabel.Text = "0:00"

            End If

            My.Settings.ShowStatusBar = OptionenDialog.StatusleisteCB.Checked
            StatusBar.Visible = My.Settings.ShowStatusBar

            If Not My.Settings.PunkteBehalten = OptionenDialog.PunkteBehaltenCB.Checked Then
                My.Settings.PunkteBehalten = OptionenDialog.PunkteBehaltenCB.Checked
                neuGeben = True
            End If
            If neuGeben Then KartenNeuGebenToolStripMenuItem_Click(sender, e)
        End If
    End Sub
    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, _
                                               ByVal e As System.EventArgs) _
                                               Handles BeendenToolStripMenuItem.Click
        Me.Close()
    End Sub
    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        MsgBox("MySolitaire" & vbCrLf & vbCrLf & "von Christian Lusser")
    End Sub

    Private Sub Mainform_Click(ByVal sender As Object, _
                                   ByVal e As System.Windows.Forms.MouseEventArgs) _
                                   Handles Me.Click

        If e.Button = Windows.Forms.MouseButtons.Right Then
            Item_Click(New CardBox(New Card()), e)
        End If

    End Sub
    Private Sub MainForm_MouseDown(ByVal sender As Object, _
                                       ByVal e As System.Windows.Forms.MouseEventArgs) _
                                       Handles Me.MouseDown

        If My.Settings.ShowTime AndAlso Not Timer1.Enabled Then
            Anfangszeitpunkt = Now
            Timer1.Start()
        End If

    End Sub
    Private Sub MainForm_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        CardBox.MouseButtonPressed = False
    End Sub
    Private Sub MainForm_Resize(ByVal sender As Form, _
                                   ByVal e As System.EventArgs) _
                                   Handles Me.Resize

        AbstandX = NullCardBox.Left
        If AbstandX < 10 Then AbstandX = 10

        If sender.WindowState = FormWindowState.Minimized Then
            If Timer1.Enabled Then Timer1.Stop()
        Else
            If My.Settings.ShowTime AndAlso Not Timer1.Enabled Then Timer1.Start()
            'KartenAbstandX = Int(Me.Size.Width / 59)
        End If

        For Each item As CardBox In CardBoxes
            item.StartPosX = item.Left
        Next

    End Sub
    Private Sub MainForm_FormClosing(ByVal sender As Object, _
                                     ByVal e As System.Windows.Forms.FormClosingEventArgs) _
                                     Handles Me.FormClosing

        Card.Deinit()
        My.Settings.MainFormPos = Me.Location

    End Sub

    Private Sub NullCard_Click(ByVal sender As CardBox, _
                               ByVal e As System.EventArgs)
        CardBox.MouseButtonPressed = False
        If My.Settings.PunkteZaehlen = PunkteZ.LasVegas Then Exit Sub


        Dim TalonRechts As New List(Of CardBox)
        For Each item As CardBox In CardBoxes
            If item.liegt = liegtE.amTalonrechts Then
                TalonRechts.Add(item)
            End If
        Next

        TalonRechts.Sort(New CardBox.CardBoxComparerByZOrder)

        Dim wiederholen As Boolean = False
        For Each item As CardBox In TalonRechts
            Karte_Bewegt(item.Name, item.StartPosX, item.StartPosY, item.ShowFace, 0, wiederholen)
            wiederholen = True
            item.ShowFace = ShowF.Backside
            item.StartPosX = AbstandX
            item.BringToFront()
        Next
        If My.Settings.PunkteZaehlen = PunkteZ.Standard Then
            Punk.te -= 100
            Karte_Bewegt("", 0, 0, ShowF.EmptyCard, -100, True)

        End If
    End Sub
    Private Sub Item_Click(ByVal sender As CardBox, _
                           ByVal e As System.Windows.Forms.MouseEventArgs)
        '                  handles CardBox.Click by addhandler


        Dim item As New CardBox(New Card()) ' has to be accessible outside foreach
        rightClickMove = False
        CardBox.MouseButtonPressed = False

        'rightClick
        If e.Button = Windows.Forms.MouseButtons.Right Then

            rightClickMove = True
            Dim hinaufgelegt As Boolean = True

            Do While hinaufgelegt
                hinaufgelegt = False
                GetHighestBoxes()
                For Each item In HighestBoxes
                    If Item_MoveUp(item, New System.Windows.Forms.MouseEventArgs(Windows.Forms.MouseButtons.None, 0, 0, 0, 0)) Then
                        hinaufgelegt = True
                        Exit For
                    End If
                Next
            Loop
            rightClickMove = False
            TestIfGameWon()

            Exit Sub
        End If

        ' Talonclick
        If e.Button = Windows.Forms.MouseButtons.Left AndAlso sender.liegt = liegtE.amTalonlinks Then
            If My.Settings.KartenZiehen = KartenZ.Eine Then
                Karte_Bewegt(sender.Name, sender.StartPosX, sender.StartPosY, sender.ShowFace)
                sender.BringToFront()
                sender.StartPosX = AbstandX + KartenSizeX + KartenAbstandX
                sender.ShowFace = ShowF.Face
            ElseIf My.Settings.KartenZiehen = KartenZ.Drei Then
                Dim TalonLinks As New List(Of CardBox)
                For Each item In CardBoxes
                    If item.Left = AbstandX AndAlso item.Top = AbstandY Then
                        TalonLinks.Add(item)
                    End If
                Next
                TalonLinks.Sort(New CardBox.CardBoxComparerByZOrder)
                Dim j As Integer = TalonLinks.Count - 1
                If j > 2 Then j = 2
                Dim Wiederholen As Boolean = False
                For i = 0 To j

                    Karte_Bewegt(TalonLinks.Item(i).Name, TalonLinks.Item(i).StartPosX, _
                                 TalonLinks.Item(i).StartPosY, TalonLinks.Item(i).ShowFace, 0, Wiederholen)
                    Wiederholen = True
                    TalonLinks.Item(i).BringToFront()
                    TalonLinks.Item(i).StartPosX = AbstandX + KartenSizeX + KartenAbstandX + (i * KartenAbstandX)
                    TalonLinks.Item(i).ShowFace = ShowF.Face
                Next
            End If
            Exit Sub
        End If

        ' Karte umdrehen
        If e.Button = Windows.Forms.MouseButtons.Left AndAlso sender.ShowFace = ShowF.Backside AndAlso sender.StartPosY > AbstandY Then
            Dim PunkteDazu As Integer = 0
            If My.Settings.PunkteZaehlen = PunkteZ.Standard Then PunkteDazu = 5
            Punk.te += PunkteDazu

            Karte_Bewegt(sender.Name, sender.StartPosX, sender.StartPosY, sender.ShowFace, PunkteDazu)
            sender.ShowFace = ShowF.Face
            Exit Sub
        End If




        'normales MouseUp, für Drag and Drop
        If Not e.Button = Windows.Forms.MouseButtons.Left Then Exit Sub

        Dim passt As Boolean = False

        ' Prüfen, ob Karte abgelegt werden kann
        For Each item In HighestBoxes
            If sender.Left < item.Right AndAlso sender.Right > item.Left AndAlso sender.Top < item.Bottom AndAlso sender.Bottom > item.Top Then
                If item.ShowFace = ShowF.Face OrElse item.Name.Contains("Stapel") OrElse item.Name.Contains("Unten") Then
                    If item.Name = sender.Name Then Continue For

                    If sender.IsHighest Then
                        If item.Name.Contains("Stapel") AndAlso sender.Card.Face = Face.Ace Then
                            passt = True
                            Exit For
                        End If
                        If item.liegt = liegtE.amStapel AndAlso item.Card.Suit = sender.Card.Suit AndAlso sender.Card.Face = item.Card.Face + 1 Then
                            passt = True
                            Exit For
                        End If
                        If item.Card.IsBlackCard = sender.Card.IsRedCard AndAlso item.Card.Face = sender.Card.Face + 1 Then
                            passt = True
                            Exit For
                        End If
                    Else    ' move more Cards
                        If item.Card.IsBlackCard = sender.Card.IsRedCard AndAlso item.Card.Face = sender.Card.Face + 1 Then
                            passt = True
                            Exit For
                        End If
                    End If

                    If item.Name.Contains("Unten") AndAlso sender.Card.Face = Face.King Then
                        passt = True
                        Exit For
                    End If
                End If
            End If
        Next

        If passt Then

            If sender.IsHighest() Then

                'Karte bewegen & Punkte zählen

                Karte_Bewegt(sender.Name, sender.StartPosX, sender.StartPosY, _
                             sender.ShowFace, CountPoints(sender, item))
                sender.StartPosX = item.Left
                If item.Top = AbstandY Then
                    sender.StartPosY = item.Top
                Else
                    sender.StartPosY = item.Top + KartenAbstandY
                End If

            Else   ' if sender not IsHighest, move more cards
                Dim wiederholen As Boolean = False
                For i = 0 To AFewCardBoxes.Count - 1
                    Karte_Bewegt(AFewCardBoxes.Item(i).Name, AFewCardBoxes.Item(i).StartPosX, _
                                 AFewCardBoxes.Item(i).StartPosY, AFewCardBoxes.Item(i).ShowFace, 0, wiederholen)
                    wiederholen = True
                    AFewCardBoxes.Item(i).StartPosX = item.Left
                    AFewCardBoxes.Item(i).StartPosY = item.Top + KartenAbstandY + (i * KartenAbstandY)
                Next
            End If

        Else ' move cards back to start location

            If sender.IsHighest Then
                sender.Left = sender.StartPosX
                sender.Top = sender.StartPosY
            Else
                For i = 0 To AFewCardBoxes.Count - 1
                    AFewCardBoxes.Item(i).Left = AFewCardBoxes.Item(i).StartPosX
                    AFewCardBoxes.Item(i).Top = AFewCardBoxes.Item(i).StartPosY
                Next
            End If

        End If

        AFewCardBoxes.Clear()


        TestIfGameWon()

    End Sub
    Private Function Item_MoveUp(ByVal sender As CardBox, _
                                 ByVal e As System.Windows.Forms.MouseEventArgs) As Boolean
        '                        handles CardBox.DblClick by addhandler

        CardBox.MouseButtonPressed = False

        If sender.liegt = liegtE.amStapel Then Return False
        If sender.ShowFace <> ShowF.Face Then Return False

        For Each item As CardBox In HighestBoxes
            If item.Name = sender.Name Then Continue For

            If item.liegt = liegtE.amStapel Then
                If item.Card.Suit = sender.Card.Suit Then
                    If (item.Card.Face + 1) = sender.Card.Face Then

                        Karte_Bewegt(sender.Name, sender.StartPosX, sender.StartPosY, _
                                     sender.ShowFace, CountPoints(sender, item))
                        sender.StartPosX = item.Left
                        sender.StartPosY = item.Top
                        sender.BringToFront()
                        If Not rightClickMove Then TestIfGameWon()

                        Return True
                    End If
                End If
            End If
            If item.Name.Contains("Stapel") Then
                If sender.Card.Face = Face.Ace Then

                    Karte_Bewegt(sender.Name, sender.StartPosX, sender.StartPosY, _
                                 sender.ShowFace, CountPoints(sender, item))
                    Dim i As Integer = GetFreeStapel()
                    sender.StartPosX = (i * (KartenSizeX + KartenAbstandX)) + (2 * (KartenSizeX + KartenAbstandX)) + AbstandX
                    sender.StartPosY = AbstandY
                    sender.BringToFront()
                    If Not rightClickMove Then TestIfGameWon()
                    Return True
                End If

            End If
        Next
        Return False

    End Function

    Private Sub Deck_create_and_shuffle()
        Deck.Clear()
        Dim rnd As New Random
        Dim c As New Card

        ' add all cards
        For i = 0 To 51
            Deck.Add(New Card(i))
        Next

        'shuffle
        For i = 0 To 51
            Thread.Sleep(1)
            c = Deck.Item(i)
            Deck.RemoveAt(i)
            Deck.Insert(rnd.Next(0, Deck.Count - 1), c)
        Next

    End Sub
    Private Function CardNr(ByVal nSuit As SuitE, _
                            ByVal nFace As Face) As Integer

        Return (nFace * 4) + nSuit

    End Function
    Private Function GetFreeStapel() As Integer

        Dim besetzt As Boolean
        For i = 1 To 4
            besetzt = False
            For Each item As CardBox In CardBoxes
                If item.Name.Contains("Stapel") Then Continue For
                If item.Top = AbstandY AndAlso item.Left = (i * (KartenSizeX + KartenAbstandX)) + (2 * (KartenSizeX + KartenAbstandX)) + AbstandX Then besetzt = True
            Next
            If besetzt = False Then Return i
        Next
        Return 0

    End Function
    Private Function TakeCardFromDeck() As Card

        If Deck.Count = 0 Then Return New Card()
        Dim c As Card = Deck.Item(0)
        Deck.RemoveAt(0)
        Return c

    End Function
    Friend Sub GetHighestBoxes()

        HighestBoxes.Clear()
        For Each item As CardBox In CardBoxes
            If item.IsHighest Then HighestBoxes.Add(item)
        Next

    End Sub
    Private Function TestIfGameWon() As Boolean

        'test ob gewonnen
        For Each item As CardBox In CardBoxes
            If item.Card.Face = Face.King Then
                If item.StartPosY > AbstandY Then Return False
                If item.StartPosX < AbstandX + (3 * (KartenSizeX + KartenAbstandX)) Then Return False
            End If
        Next

        'hat gewonnen
        If Timer1.Enabled Then Timer1.Stop()


        Dim msg As String = ""
        If My.Settings.ShowTime Then
            msg &= "Benötigte Zeit: " & ZeitTSSLabel.Text & vbCrLf
            If My.Settings.PunkteZaehlen = PunkteZ.Standard Then
                Dim bonus As Integer = 700000 \ Int(Zeit.TotalSeconds) 'diese werte stammen von msdn :-)
                If bonus > 23334 Then bonus = 0
                msg &= "Bonuspunkte: " & bonus.ToString & vbCrLf & vbCrLf
                Punk.te += bonus
            End If
        End If
        msg &= "Karten neu geben?"


        If MsgBox(msg, MsgBoxStyle.YesNo, "Gewonnen!") = MsgBoxResult.Yes Then

            KartenNeuGebenToolStripMenuItem_Click(Me, New System.EventArgs())
        Else
            Me.Controls.Clear()
            InitializeComponent()

            AFewCardBoxes.Clear()
            CardBoxes.Clear()
        End If

        Return True

    End Function
    Private Function CountPoints(ByVal sender As CardBox, ByVal item As CardBox) As Integer
        Dim PunkteDazu As Integer = 0
        If item.liegt = liegtE.amStapel Then
            If My.Settings.PunkteZaehlen = PunkteZ.LasVegas Then
                PunkteDazu = 5
            Else
                PunkteDazu = 10
            End If
        End If
        If item.liegt = liegtE.unten AndAlso sender.liegt = liegtE.amStapel Then
            If My.Settings.PunkteZaehlen = PunkteZ.LasVegas Then
                PunkteDazu = -5
            Else
                PunkteDazu = -10
            End If
        End If
        If item.liegt = liegtE.unten AndAlso sender.liegt = liegtE.amStapel AndAlso My.Settings.PunkteZaehlen = PunkteZ.Standard Then
            PunkteDazu = 5
        End If
        Punk.te += PunkteDazu
        Return PunkteDazu
    End Function
    Private Sub Karte_Bewegt(ByVal BKName As String, _
                                 Optional ByVal BKStartPosX As Integer = 0, _
                                 Optional ByVal BKStartPosY As Integer = 0, _
                                 Optional ByVal BKShowFace As ShowF = ShowF.Face, _
                                 Optional ByVal PunkteDazu As Integer = 0, _
                                 Optional ByVal WiederHolen As Boolean = False)

        'UndoWert schreiben
        Dim item As UnDoWert
        item.BK_Name = BKName
        item.BK_StartPosX = BKStartPosX
        item.BK_StartPosY = BKStartPosY
        item.BK_ShowFace = BKShowFace
        item.Punkte_Dazu = PunkteDazu
        item.UnDoWiederholen = WiederHolen
        UnDoWerte.Insert(0, item)

        UnDoToolStripMenuItem.Enabled = True

    End Sub
    Private Sub Punkte_Changed() Handles Punk.ValueChanged
        If Punk.te < 0 Then
            PunkteTSSLabel.ForeColor = Color.Red
        Else
            PunkteTSSLabel.ForeColor = Color.Black
        End If
        If My.Settings.PunkteZaehlen = PunkteZ.LasVegas Then PunkteTSSLabel.Text = String.Format("{0:c0}", Punk.te)
        If My.Settings.PunkteZaehlen = PunkteZ.Standard Then PunkteTSSLabel.Text = Punk.te.ToString
        If My.Settings.PunkteZaehlen = PunkteZ.Keine Then PunkteTSSLabel.Text = ""

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, _
                            ByVal e As System.EventArgs) _
                            Handles Timer1.Tick

        Zeit = Now - Anfangszeitpunkt
        ZeitTSSLabel.Text = Int(Zeit.TotalMinutes) & ":" & String.Format("{0:00}", Zeit.Seconds)
        If My.Settings.PunkteZaehlen = PunkteZ.Standard AndAlso Zeit.Seconds Mod 10 = 0 Then
            Punk.te -= 2

        End If
    End Sub


End Class


